Imports System.Net
Imports System.Net.Sockets
Imports System.IO

''' <summary>
''' Dieses Form kann sowohl als Server-Anwendung laufen, als auch als Client-Anwendung
''' </summary>
Public Class frmServer




   Private WithEvents _ServerOrClient As Server 'polymorphes Objekt


   Private Sub AddClientToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddClientToolStripMenuItem.Click

   End Sub
   Private Sub MenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
           Handles _
           SendMessageToolStripMenuItem.Click, AddClientToolStripMenuItem.Click, BeServerToolStripMenuItem.Click,
           TestToolStripMenuItem.Click, OuterIPToolStripMenuItem.Click
      Select Case True
         Case sender Is SendMessageToolStripMenuItem
            If _ServerOrClient Is Nothing Then
               DisplayStatusLine("Fehler:", Lf, "no Connection")
            Else
               _ServerOrClient.Send(Me.rtbSend.Text)
            End If

         Case sender Is AddClientToolStripMenuItem
            Call (New frmClient()).Show(Me)

         Case sender Is BeServerToolStripMenuItem
            DisposeAll(_ServerOrClient)
            Dim EP As IPEndPoint = GetEP()
            If EP Is Nothing Then Return
            _ServerOrClient = New Server(EP)
            DisplayStatusLine("Hi!", Lf, "I'm the Server, listening to:", Lf, EP)
            Me.Text = "Server"

         Case sender Is OuterIPToolStripMenuItem
            frmOuterIP.Show(Me)

         Case sender Is TestToolStripMenuItem

      End Select
   End Sub


   'diese Sub ist normalerweise in der Designer.vb. Ich will aber sicherstellen kann, da _ServerOrClient **vor** den components disposed. Sonst empfngter womglich noch Daten, und will die darstellen.
   Protected Overrides Sub Dispose(ByVal disposing As Boolean)
      DisposeAll(_ServerOrClient)
      If disposing AndAlso components IsNot Nothing Then
         components.Dispose()
      End If
      MyBase.Dispose(disposing)
   End Sub

#Region "ServerOrClient-Ereignisverarbeitung"

   Private Sub ServerOrClient_ChatMessage(ByVal Sender As Object, _
          ByVal e As NotifyEventArgs(Of String)) Handles _ServerOrClient.ChatMessage
      DisplayLine(e.Value)
   End Sub

   Private Sub _ServerOrClient_Disposed(ByVal Sender As Server) Handles _ServerOrClient.Disposed
      _ServerOrClient = Nothing
      Me.Text = "Offline"
   End Sub

   Private Sub ServerOrClient_StatusMessage(ByVal Sender As Object, _
          ByVal e As NotifyEventArgs(Of String)) Handles _ServerOrClient.StatusMessage
      DisplayStatusLine(e.Value)
   End Sub

#End Region 'ServerOrClient-Ereignisverarbeitung

   Private Function GetEP() As IPEndPoint
      Dim DefaultIP As String = ""
      Dim addresses As IPAddress() = Dns.GetHostEntry(My.Computer.Name).AddressList
      If addresses.Length = 1 Then DisplayStatusLine("Sie sind Offline!")
      Array.Reverse(addresses)
      For Each addr As IPAddress In addresses
         If addr.AddressFamily = AddressFamily.InterNetwork Then
            DefaultIP = String.Concat(addr, " : 12345")
            Exit For
         End If
      Next
      Dim InputIP As String = InputBox( _
         "( voreingestellt: eigene IP  und willkrlicher Port )", _
         "IP eingeben", _
         DefaultIP)
      Try
         'schlampige Fehlerbehandlung, weil ich zu faul bin, alle Mglichkeiten differenziert zu betrachten
         Dim Splitted As String() = InputIP.Split(":"c)
         Dim IPAs As IPAddress() = Dns.GetHostAddresses(Splitted(0))
         Return New IPEndPoint(IPAs(0), Integer.Parse(Splitted(1)))
      Catch ex As Exception
         DisplayStatusLine("Die IP '", InputIP, "' konnte nicht aufgelst werden")
         Return Nothing
      End Try
   End Function


   Private Sub DisplayLine(ByVal Msg As String)
      Me.rtbLog.AppendText(Msg & Lf)
   End Sub

   ''' <summary>Meldung hellgelb hinterlegt anzeigen</summary>
   Private Sub DisplayStatusLine(ByVal ParamArray Items() As Object)
      Static StatusLineColor As Color = Color.FromArgb(255, 255, 200)
      Me.rtbLog.SelectionBackColor = StatusLineColor
      DisplayLine(String.Concat(Items))
      Me.rtbLog.SelectionBackColor = Color.White
   End Sub

End Class